<?php
  
$wpTimeMachineOptions = array(
    'offsite' => '',
    'use_timestamp_dir' => 'false',
    'use_log' => 'true',
    'show_info' => 'true',
    'show_option' => 'true',
    'format' => 'zip',
    'remote_user' => 'true',
    'remote_pass_stored' => 'false',
    'remote_host' => '',
    'remote_pass' => '',
    'remote_path' => ''
);

define("wpTimeMachineOptions", serialize($wpTimeMachineOptions));
    
if (!class_exists("wpTimeMachine")) {

	class wpTimeMachine {
		
      // Constructor
      
		function wpTimeMachine() { 
		}
		
      // init / main 
		
		function init() {
                		
		  // Constants
		  
		    $this->logger( $use_log,  '*** wpTimeMachine plugin loaded ***' );
            
            $wpTimeMachineFile    = "wpTimeMachineCore.php5";
            
            $wpcontent_dir        = ( defined('WP_CONTENT_DIR') ) ? WP_CONTENT_DIR : ABSPATH . 'wp-content';
            $wpcontent_url        = ( defined('WP_CONTENT_URL') ) ? WP_CONTENT_URL : get_option('siteurl') . '/wp-content';
            $wpplugin_dir         = ( defined('WP_PLUGIN_DIR')  ) ? WP_PLUGIN_DIR  : $wpcontent_dir . '/plugins';
            $wp_version           = get_bloginfo( 'version' );
            $wp_installer_url     = "http://wordpress.org/wordpress-".$wp_version;                
            $wpcontent_archive    = $wpcontent_dir . "/wpTimeMachine-content-files";
            $wpdata_sql           = $wpcontent_dir . "/wpTimeMachine-data-files.sql";
            $htaccess_archive     = $wpcontent_dir . "/wpTimeMachine-htaccess";   
            $instructions         = $wpcontent_dir . "/wpTimeMachine-Instructions.txt";  
            $super_archive        = $wpcontent_dir . "/wpTimeMachine-archive";  

		  // Get / Set Plugin Settings
		
            $wpTimeMachineOptionsStorage = $this->getAdminOptions();

            if (isset($_GET['show_info'])) {
                $wpTimeMachineOptionsStorage['show_info'] = $_GET['show_info'];
            } 
            
            if (isset($_GET['use_log'])) {
                $wpTimeMachineOptionsStorage['use_log'] = $_GET['use_log'];
            } 

            if (isset($_GET['show_options'])) {
                $wpTimeMachineOptionsStorage['show_options'] = $_GET['show_options'];
            } 
            
            if (isset($_GET['format'])) {
                $wpTimeMachineOptionsStorage['format'] = $_GET['format'];
            } 
            
            if (isset($_GET['use_timestamp_dir'])) {
                $wpTimeMachineOptionsStorage['use_timestamp_dir'] = $_GET['use_timestamp_dir'];
            } 
            
            if (isset($_POST['offsite'])) {
                $wpTimeMachineOptionsStorage['offsite'] = $_POST['offsite'];
            } 

            if (isset($_POST['remote_user'])) {
                $wpTimeMachineOptionsStorage['remote_user'] = $_POST['remote_user'];
            } 

            if (isset($_POST['remote_host'])) {
                $wpTimeMachineOptionsStorage['remote_host'] = $_POST['remote_host'];
            } 

            if (isset($_POST['remote_path'])) {
                $wpTimeMachineOptionsStorage['remote_path'] = $_POST['remote_path'];
            } 
              
            if (isset($_GET['remote_pass_storage'])) {
                $wpTimeMachineOptionsStorage['remote_pass_storage'] = $_GET['remote_pass_storage'];
                
                if ($_GET['remote_pass_storage'] == "false") {
                    $wpTimeMachineOptionsStorage['remote_pass'] = "";
                } 
            } 
            
            if (isset($_POST['remote_pass'])) {
                if ($wpTimeMachineOptionsStorage['remote_pass_storage'] == "true") {
                    $wpTimeMachineOptionsStorage['remote_pass'] = $_POST['remote_pass'];
                }                
            } 
                
            update_option($this->adminOptionsName, $wpTimeMachineOptionsStorage);
                       
            $offsite = $wpTimeMachineOptionsStorage['offsite'];
            
            $use_log = $wpTimeMachineOptionsStorage['use_log'];
        
            if ($wpTimeMachineOptionsStorage['format'] == "zip") {
                $format = ".zip";
            } else {
                $format = ".tar.gz";
            }

            $wp_installer_url .= $format;
            
            $files = array( $wpcontent_archive . $format, $wpdata_sql, $htaccess_archive . $format, $instructions ); 
     
            if ($wpTimeMachineOptionsStorage['use_timestamp_dir'] == "true") {
                $timestamp = date("Y-m-d");
            } else {
                $timestamp = "";
            }
               
		    $this->logger( $use_log,  '*** wpTimeMachine plugin loaded '.wpTimeMachineVersion.' ***' );
			
            // Browser / user-agent
                $this->logger( $use_log,  "### Browser: ". $_SERVER['HTTP_USER_AGENT'] );
            // PHP Version
                $this->logger( $use_log,  "### PHP: version ". phpversion() );
            // cURL extension
            if ( function_exists("curl_version") ) {        
                $cURL_version = curl_version();            
                $this->logger( $use_log,  "### cURL: version " . $cURL_version['version']);            
            } else {        
                $this->logger( $use_log,  "### cURL: no cURL extension");       
            }    
            // system command
            if ( function_exists("system") ) {            
                $this->logger( $use_log,  "### system() command: yes");            
            } else {        
                $this->logger( $use_log,  "### system() command: no ");        
            }    
            // shell_exec command
            if ( function_exists("shell_exec") ) {            
                $this->logger( $use_log,  "### shell_exec() command: yes");            
            } else {        
                $this->logger( $use_log,  "### shell_exec() command: no ");        
            }   
            // writable wp-content    
            if ( is_writeable($wpcontent_dir) ) {        
                $this->logger( $use_log,  "### wp-content writable: yes");            
            } else {        
                $this->logger( $use_log,  "### wp-content writable: no");        
            }   
         
          // Strings based on $offsite 

		    $this->logger( $use_log,  '--- provider: '.$offsite );
          
            switch ($offsite) {
        
                case "dropbox":
                    $remote_user_label = "Email";
                    $remote_pass_label = "Password";
                    $remote_path_label = "Directory";
                    $offsite_name = "Dropbox";
                    break;
        
                case "aws_s3":
                    $remote_user_label = "S3 Key";
                    $remote_pass_label = "S3 Secret";
                    $remote_path_label = "Bucket";
                    $offsite_name = "Amazon S3";
                    break;

                case "ftp":    
                    $remote_user_label = "Username";
                    $remote_pass_label = "Password";
                    $remote_path_label = "Directory";
                    $offsite_name = "FTP";
                    break;
                    
                default:                    
                    $remote_user_label = "Remote User ID";
                    $remote_pass_label = "Remote User's Password";
                    $remote_path_label = "Remote Path";
                    $offsite_name = "";
                    break;

            }
  
          // begin plugin UI ...
          
    		?>
    		
    		<style type="text/css">
    		@import url('<?php echo $wpcontent_url; ?>/plugins/wp-time-machine/css/wp-time-machine.css');
        		
    		<?php 
    		if ($wpTimeMachineOptionsStorage['show_options'] == "true") { 
                echo ".wpTimeMachineOptions {display:block;}";
            } else {
                echo ".wpTimeMachineOptions {display:none; }";
            }
            ?>
    		</style>
    		
    		<script type="text/javascript" src="http://www.google.com/jsapi"></script>
    		<script type="text/javascript"> if (!jQuery) google.load( "jquery","1.3.2" ); </script>
    		<script type="text/javascript" src="<?php echo $wpcontent_url; ?>/plugins/wp-time-machine/javascript/jquery.form.js"></script>
            <script type="text/javascript" src="<?php echo $wpcontent_url; ?>/plugins/wp-time-machine/javascript/jquery.validate.js"></script>
            <script type="text/javascript" src="<?php echo $wpcontent_url; ?>/plugins/wp-time-machine/javascript/jquery.additional-methods.js"></script>
    		<script type="text/javascript">
    		
    		var dropbox_labels = new Array("Email","Password","Directory");
    		var s3_labels = new Array("S3 Key","S3 Secret","Bucket");
    		var ftp_labels = new Array("Username","Password","Directory");
    		
    		function wpTimeMachine_toggle( key, negative, positive ) {

                //jQuery("#submit_package_request").css("opacity","0.1").attr("disabled", "true");
                        
                if ( jQuery("#"+key).attr("value") == "false" ) {
                    var val = true;
                    jQuery("#"+key).text( negative );                    
                } else {
                    var val = false;
                    jQuery("#"+key).text( positive );
                }
                            
                if (key == "format") {

                    if (jQuery("#"+key).attr("value") == "zip") {
                        jQuery("#"+key).text( negative ).attr("value","tar");
                        jQuery("#"+key+"_label").text(".tar.gz");                    
                    } else {
                        jQuery("#"+key).text( positive ).attr("value","zip");
                        jQuery("#"+key+"_label").text(".zip");  
                    }

                    var val = jQuery("#"+key).attr("value");
                    
                }

                jQuery("#"+key).attr("value", val);
                
                if (key == "use_timestamp_dir") {
                
                    jQuery("input[name='use_timestamp_dir']").val(val);
                
                }
                
                if (key == "show_info") {
                    jQuery("#Info").slideToggle();
                }
                
                if (key == "show_options") {
                    jQuery(".wpTimeMachineOptions").slideToggle();
                }
                    
                jQuery.ajax({ 
                    data:    "page=<?php echo $wpTimeMachineFile; ?>&generate=1&"+key+"="+val,
                    url:     "options-general.php",
                    complete: function () {
                    
                        //jQuery("#submit_package_request").css("opacity","1.0").attr("disabled", "false");
                    
                        return false;
                    }
                });
    		
    		}

    		jQuery(document).ready( function(){
            	
                var rh_fields = jQuery("label[for='remote_host'],input[name='remote_host'],#remote_host_advice");
    		
    		<?php
    		if ($wpTimeMachineOptionsStorage['offsite'] != "ftp") {    		
    		?>
        		rh_fields.hide();
            <?php            
            } else {            
            ?> 
        		rh_fields.show(); 
            <?php            
            }            
            ?>

            	jQuery("#show_info").click( function (event) {
                    event.preventDefault();
                    wpTimeMachine_toggle( "show_info", "Hide instructional text", "Show instructional text" );
            	});

            	jQuery("#use_log").click( function (event) {
                    event.preventDefault();
                    wpTimeMachine_toggle( "use_log", "Stop logging", "Start logging" );
            	});
            	
            	jQuery("#show_options").click( function (event) {
                    event.preventDefault();
                    wpTimeMachine_toggle( "show_options", "Hide plugin options", "Show plugin options" );
            	});
            	
            	jQuery("#format").click( function (event) {
                    event.preventDefault();
                    wpTimeMachine_toggle( "format", "Use Zip files", "Use tarball (tar.gz) files" );
            	});
            	
            	jQuery("#use_timestamp_dir").click( function (event) {
                    event.preventDefault();
                    wpTimeMachine_toggle( "use_timestamp_dir", "Stop using time-stamped subdirectories to store multiple backups.", "Use time-stamped subdirectories to store multiple backups." );
            	});
            	
            	jQuery("#remote_pass_storage").click( function (event) {
                    event.preventDefault();
                    wpTimeMachine_toggle( "remote_pass_storage", "Don't save my <?php echo $remote_pass_label; ?>.", "Save my <?php echo $remote_pass_label; ?>." );
            	});

            	jQuery(".rd").click( function() {
            	
                    var offsite = jQuery(this).val();
                    var storage_text = jQuery("#remote_pass_storage").text();
                    
                    switch (offsite) {
                    
                        case "aws_s3":
                            jQuery("label[for='remote_user']").text( s3_labels[0]+": ");
                            jQuery("label[for='remote_pass']").text( s3_labels[1]+": ");
                            jQuery("label[for='remote_path']").text( s3_labels[2]+": ");
                            jQuery("#remote_pass_label").text(s3_labels[1]);                               
                            rh_fields.hide();                         
                            break;
                        
                        case "ftp":
                            jQuery("label[for='remote_user']").text( ftp_labels[0]+": ");
                            jQuery("label[for='remote_pass']").text( ftp_labels[1]+": ");
                            jQuery("label[for='remote_path']").text( ftp_labels[2]+": ");
                            jQuery("#remote_pass_label").text(ftp_labels[1]);                            
                            rh_fields.show();                             
                            break;
                        
                        default:
                        //case "dropbox":
                            jQuery("label[for='remote_user']").text( dropbox_labels[0]+": ");
                            jQuery("label[for='remote_pass']").text( dropbox_labels[1]+": ");
                            jQuery("label[for='remote_path']").text( dropbox_labels[2]+": ");
                            jQuery("#remote_pass_label").text(dropbox_labels[1]);                            
                            rh_fields.hide(); 

                    }           	   
            	
            	});

                jQuery('#wpTimeMachine_generator_form').ajaxForm({ 
                    beforeSubmit: function() {
                        jQuery("#info, #help_links, #wpTimeMachine_generator_form,#wpTimeMachine_complete")
                            .fadeOut('fast', function() {
                                jQuery("#wpTimeMachine_progress").show();
                            });
                    },  
                    success: function() {
                        jQuery("#wpTimeMachine_progress")
                            .fadeOut('fast', function() {
                                jQuery("#info, #help_links, #wpTimeMachine_generator_form,#wpTimeMachine_complete").show();
                            });
                    }  
                }); 

            });
                		
    		</script>

            <div class="wrap" id="wpTimeMachine">

            <?php  
            
            // start inline instructions
            
                echo "<h2>wp Time Machine, version: " . wpTimeMachineVersion . "</h2>";
            
            if ($wpTimeMachineOptionsStorage['show_info'] != "true") {            
                echo "<div id=\"Info\" style=\"display:none\">";          
            } else {          
                echo "<div id=\"Info\">";               
            }  
            
                require 'wpTimeMachineIntructions.php5.html';
            
                echo "</div>";
            
                echo "<div id=\"help_links\">";
                           
                if ($wpTimeMachineOptionsStorage['show_info'] == "true") {
                    echo '<a href="javascript:void(0)" id="show_info" value="true">Hide instructional text</a> &nbsp;&nbsp;';
                } else { 
                    echo '<a href="javascript:void(0)" id="show_info" value="false">Show instructional text</a> &nbsp;&nbsp;';
                }
                    
                if ($wpTimeMachineOptionsStorage['show_options'] == "true") {
                    echo '<a href="javascript:void(0)" id="show_options" value="true">Hide plugin options</a> &nbsp;&nbsp;';
                } else { 
                    echo '<a href="javascript:void(0)" id="show_options" value="false">Show plugin options</a> &nbsp;&nbsp;';
                }

                if ($wpTimeMachineOptionsStorage['use_log'] == "true") {
                    echo '<a href="javascript:void(0)" id="use_log" value="true">Stop logging</a> &nbsp;&nbsp;';
                } else { 
                    echo '<a href="javascript:void(0)" id="use_log" value="false">Start logging</a> &nbsp;&nbsp;';
                }
                
                if ( file_exists( $wpcontent_dir . "/wpTimeMachine_log.txt" ) ) {
                    echo '<a href="'. $wpcontent_url .'/wpTimeMachine_log.txt" target="_new">View log</a> &nbsp;&nbsp;';
                }
                
                echo "</div>";
            
            // end inline instructions
              
            ?>    
                <p>
                
                    <div id="wpTimeMachine_progress" style="display:none"> 
                    
                        <h2>Please wait while your files &amp; data are being archived</h2>
                        
                        <p> 
                            Please, don't close this window or tab. <br /><br />
                            A confirmation will appear when the process has completed...
                        </p>
                    
                    </div>
                
                    <div id="wpTimeMachine_complete" style="display:none"> 
                    
                        <h2>Your archives have been completed</h2>
                        
                        <p> 
                            They should now be available via your offsite provider: <br /><br />
                            <?php

                            echo $offsite_name;
                        
                            if ($offsite_name == "FTP") {                            
                                echo " &nbsp; ftp://";
                                echo $wpTimeMachineOptionsStorage['remote_user'] . "@";
                                echo $wpTimeMachineOptionsStorage['remote_host'] . ":";
                                echo $wpTimeMachineOptionsStorage['remote_path'];                            
                            }      
                                                  
                            ?><br /><br />
                            <a href="javascript:void(0)" onclick="jQuery('#wpTimeMachine_complete').hide()">Remove this message</a>                            
                        </p>
                    
                    </div>
          
                    <form id="wpTimeMachine_generator_form" method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>&generate=1&time=<?php echo time(); ?>">
                    
                        <?php wp_nonce_field('wpTimeMachine_nonce'); ?>
                    
                        <fieldset class="wpTimeMachineOptions">
                        
                        <?php                         
                        if ($offsite != "") {                        
                            ?>
                            <label for="offsite" class="offsite">                            
                            Current offsite service: <strong><?php echo $offsite_name; ?></strong>
                            &nbsp;&nbsp;<a href="javascript:void(0)" onclick="jQuery('#offsite_selections').toggle()">Change your offsite service</a>                             
                            </label> <br />
                            <span id="offsite_selections" style="display:none">
                            <?php                            
                        } else {                        
                            ?>
                            <label for="offsite">Select an offsite service:</label> <br />
                            <?php                        
                        }                        
                            ?>
                            <input class="rd" type="radio" name="offsite" value="dropbox"> Dropbox (<a href="https://www.dropbox.com/referrals/NTE0ODYwNjc5" target="_new">https://dropbox.com</a>) <br />
                            <input class="rd" type="radio" name="offsite" value="aws_s3"> Amazon S3 (<a href="https://s3.amazonaws.com/" target="_new">https://s3.amazonaws.com</a>) <br />
                            <input class="rd" type="radio" name="offsite" value="ftp"> FTP <br />
                            
                            <script type="text/javascript">

                            jQuery("input[value='<?php echo $offsite; ?>']").attr("checked", true);
                            
                            </script>
                            
                            <?php                         
                        if ($offsite != "") {                        
                            ?>
                            </span>
                            <?php
                        }                        
                        ?>
                        
                        </fieldset>    
                                        
                        <fieldset class="wpTimeMachineOptions">
                        
                            File format:   
                            <?php                      
                            if ($wpTimeMachineOptionsStorage['format'] == "zip") {
                                echo '<strong id="format_label">.zip</strong> &nbsp;&nbsp;<a href="javascript:void(0)" id="format" value="zip">Use tarball (tar.gz) files</a>';
                            } else { 
                                echo '<strong id="format_label">.tar.gz</strong> &nbsp;&nbsp;<a href="javascript:void(0)" id="format" value="tar">Use Zip files</a>';
                            }
                            ?>
                        
                        </fieldset>
                
                        <fieldset class="wpTimeMachineOptions">
                                
                        <?php                         
                        if ($wpTimeMachineOptionsStorage['use_timestamp_dir'] == "true") {                        
                            ?>
                            <a href="javascript:void(0)" id="use_timestamp_dir" value="true">Stop using time-stamped subdirectories to store multiple backups.</a>
                            <input type="hidden" name="use_timestamp_dir" value="true" />
                            <?php                        
                        } else {                         
                            ?>
                            <a href="javascript:void(0)" id="use_timestamp_dir" value="false">Use time-stamped subdirectories to store multiple backups.</a>
                            <input type="hidden" name="use_timestamp_dir" value="false" />
                            <?php                        
                        }                        
                        ?>
                        
                            &nbsp;&nbsp; <a href="javascript:void(0)" onclick="jQuery('#wpTimeMachine_learn_about_timestamps').toggle()">Learn more</a> 
                            
                            <p id="wpTimeMachine_learn_about_timestamps" class="help" style="display:none">
                            
                            This feature adds a date to paths or files <br />(depending on which offsite service you use).<br /><br />
                            For example, if you use Dropbox, the folder the archives appear in will now look like folder-YEAR-MONTH-DAY (or wpTimeMachine-2010-04-15).
                            This is helpful if you want to have archives kept of relatively discrete changes; but can consume a lot of space.  At this time the plugin
                            makes no attempt to delete archives of this type beyond a certain date.  What you archive stays until you delete it...
                            
                            </p>
                        
                        </fieldset>
                        
                        <fieldset>

                            <label for="remote_user"><?php echo $remote_user_label; ?>: </label>                             
                                <?php 
                                if ($wpTimeMachineOptionsStorage['remote_user'] != "true") {                                
                                    $wpTimeMachine_remote_user_display = $wpTimeMachineOptionsStorage['remote_user'];                                    
                                } else {                                    
                                    $wpTimeMachine_remote_user_display = "";                                    
                                }                                 
                                ?>                            
                                <input type="text" name="remote_user" value="<?php echo $wpTimeMachine_remote_user_display; ?>" /> <br />
    
                            <label for="remote_pass"><?php echo $remote_pass_label; ?>: </label>                             
                                <input type="password" id="remote_pass" name="remote_pass" value="<?php echo $wpTimeMachineOptionsStorage['remote_pass']; ?>" />                                 
                                <?php                                 
                                if ($wpTimeMachineOptionsStorage['remote_pass_storage'] == "true") {                                
                                    ?>
                                    <a href="javascript:void(0)" id="remote_pass_storage" value="true">
                                        Don't save my <span id="remote_pass_label"><?php echo $remote_pass_label; ?></span>.
                                    </a>
                                    <?php                                
                                } else {                                 
                                    ?>
                                    <a href="javascript:void(0)" id="remote_pass_storage" value="false">
                                        Save my <span id="remote_pass_label"><?php echo $remote_pass_label; ?></span>.
                                    </a>
                                    <?php                                
                                }                                
                                ?>                                
                                <br />

                            <label for="remote_host">Remote Host: </label>                             
                                <input type="text" name="remote_host" value="<?php echo $wpTimeMachineOptionsStorage['remote_host']; ?>" /> <em id="remote_host_advice">(FTP only!)</em> 
    
                            <label for="remote_path"><?php echo $remote_path_label; ?>: </label>                             
                                <input type="text" name="remote_path" value="<?php echo $wpTimeMachineOptionsStorage['remote_path']; ?>" /> <em>(Optional &amp; <a href='http://wptimemachine.com/' target='_new'>Tips</a>)</em> <br />

                        </fieldset>
                      
                        <div class="submit">
                            <input class="sb" type="submit" id="submit_package_request" value="Generate wp Time Machine archives" />
                        </div>
                        
                    </form>

                </p>

                <pre id="output" style="display:none">

                <?php
                
                if ($_GET['generate'] == 1) {
                
                    $this->logger( $use_log,  '--- generate archives request, for ' . $offsite );
                
                  // validate referer & nonce
                  
                    check_admin_referer('wpTimeMachine_nonce');
            
                  // generate instructions text file
                  
                    require("wpTimeMachineIntructionsTextFile.php5");
                    
                    $this->logger( $use_log,  '--- generate text instructions' );
                    
                  // mysql dump
                    
                    $database = DB_NAME;
                    
                    $query = '';
                    
                    $tables = @mysql_list_tables($database);
                    
                    while ($row = @mysql_fetch_row($tables)) { $table_list[] = $row[0]; }
                    
                    for ($i = 0; $i < @count($table_list); $i++) {
                    
                        $results = mysql_query('DESCRIBE ' . $database . '.' . $table_list[$i]);
                        
                        $query .= 'DROP TABLE IF EXISTS `' . $database . '.' . $table_list[$i] . '`;' . lnbr;
                        $query .= lnbr . 'CREATE TABLE `' . $database . '.' . $table_list[$i] . '` (' . lnbr;
                        
                        $tmp = '';
                        
                        while ($row = @mysql_fetch_assoc($results)) {
                        
                            $query .= '`' . $row['Field'] . '` ' . $row['Type'];
                        
                            if ($row['Null'] != 'YES') { $query .= ' NOT NULL'; }
                            if ($row['Default'] != '') { $query .= ' DEFAULT \'' . $row['Default'] . '\''; }
                            if ($row['Extra']) { $query .= ' ' . strtoupper($row['Extra']); }
                            if ($row['Key'] == 'PRI') { $tmp = 'primary key(' . $row['Field'] . ')'; }
                            
                            $query .= ','. lnbr;
                        
                        }
                        
                        $query .= $tmp . lnbr . ');' . str_repeat(lnbr, 2);
                        
                        $results = mysql_query('SELECT * FROM ' . $database . '.' . $table_list[$i]);
                        
                        while ($row = @mysql_fetch_assoc($results)) {
                        
                            $query .= 'INSERT INTO `' . $database . '.' . $table_list[$i] .'` (';
                        
                            $data = Array();
                        
                            while (list($key, $value) = @each($row)) { $data['keys'][] = $key; $data['values'][] = addslashes($value); }
                        
                            $query .= join($data['keys'], ', ') . ')' . lnbr . 'VALUES (\'' . join($data['values'], '\', \'') . '\');' . lnbr;
                        
                        }
                        
                        $query .= str_repeat(lnbr, 2);
                    
                    }

                    $dump_handle = fopen($wpdata_sql, 'a+');
                    fwrite($dump_handle, $query);
                    fclose($dump_handle);                    
                                        
                    $this->logger( $use_log,  '--- generate mysql dump' );
                    
                  // generate archives
                    
                    $this->logger( $use_log,  '--- generate archives as ' . $format );

                    if ($format == "zip") {
                    
                        $wpcontent_archive_obj = new Archive_Zip( $wpcontent_archive.$format );
                        $htaccess_archive_obj = new Archive_Zip( $htaccess_archive.$format );
                        $super_arch_obj = new Archive_Zip( $super_archive.$format );
                        
                        $wpcontent_archive_files = array( $wpcontent_dir );
                        $htaccess_arch_files = array( $_SERVER['DOCUMENT_ROOT'] . "/.htaccess" );
                        $super_arch_files = array( $wpcontent_archive.$format, $wpdata_sql, $htaccess_archive.$format, $instructions );
    
                        if ($wpcontent_archive_obj->create( $wpcontent_archive_files ) ) {
                            if ($htaccess_archive_obj->create( $htaccess_arch_files ) ) {
                                $super_arch_obj->create( $super_arch_files );
                            }
                        }
                            
                    } else {

                        $wpcontent_archive_obj = new Archive_Tar( $wpcontent_archive.$format );
                        $htaccess_archive_obj = new Archive_Tar( $htaccess_archive.$format );
                        $super_arch = new Archive_Tar( $super_archive.$format );
                        
                        $wpcontent_archive_files = array( $wpcontent_dir );
                        $htaccess_arch_files = array( $_SERVER['DOCUMENT_ROOT'] . "/.htaccess" );
                        $super_arch_files = array( $wpcontent_archive.$format, $wpdata_sql, $htaccess_archive.$format, $instructions );
    
                        if ($wpcontent_archive_obj->create( $wpcontent_archive_files ) ) {
                            if ($htaccess_archive_obj->create( $htaccess_arch_files ) ) {
                                $super_arch->create( $super_arch_files );
                            }
                        }                   
                    
                    }
                    
                    $this->logger( $use_log,  '--- generate archive files complete.' );
                            
                  // start processing the files
                    
                    switch ($offsite) {
                
                        case "dropbox":
                        
                            $this->logger( $use_log,  '--- initiate transfer to ' . $offsite );
                        
                            $uploader = new DropboxUploader( $_POST['remote_user'], $_POST['remote_pass'] );
                            
                            $this->logger( $use_log,  '--- instantiate ' . $offsite );

                            if ($_POST['remote_path'] == "") {
                                $dropbox_dir = "/wpTimeMachine";
                            } else {
                                $dropbox_dir = "/" . $_POST['remote_path'] ;
                            }
                        
                            if ($timestamp != "") {
                                $dropbox_dir .= "-" . $timestamp;
                            } 
                        
                            $uploader->upload( $super_archive.$format, $remoteDir = $dropbox_dir );
                            
                            $this->logger( $use_log,  '--- finish transfer' );

                            break;

                        case "aws_s3":
                            
                            $this->logger( $use_log,  '--- initiate transfer to ' . $offsite );

                            if ($_POST['remote_path'] == "") {
                                $bucket = "wpTimeMachine";
                            } else {
                                $bucket = $_POST['remote_path'] ;
                            }
                        
                            if ($timestamp != "") {
                                $bucket .= "-" . $timestamp;
                            } 
                                
                            $bucket = uniqid( $bucket . "-" );

                            $s3 = new S3( $_POST['remote_user'], $_POST['remote_pass'] );
                            
                            $this->logger( $use_log,  '--- instantiate ' . $offsite );
                            
                            $s3->putBucket( $bucket, S3::ACL_PRIVATE );
                            $s3->putObjectFile( $super_archive.$format, $bucket, baseName( $super_archive.$format ), S3::ACL_PRIVATE );
                            
                            $this->logger( $use_log,  '--- finish transfer' );

                            break;

                        case "ftp":
                        
                            $this->logger( $use_log,  '--- initiate transfer to ' . $offsite );

                            $conn = ftp_connect( $_POST['remote_host'] ); 
                            
                            $this->logger( $use_log,  '--- create ftp connection ' );
                                                           
                            ftp_login( $conn, $_POST['remote_user'], $_POST['remote_pass'] );  
                            
                            $this->logger( $use_log,  '--- login to ftp ' );
                                                          
                            ftp_chdir( $conn, "/".$_POST['remote_path'] );                            
                            
                            $remote_file = baseName( $super_archive.$format );
                        
							if ($_POST['remote_path'] == "") {
                                $remote_file = "/" . $remote_file;
                            } else {
                                $remote_file = "/" . $_POST['remote_path'] . "/" . $remote_file;
                            }
                            
                            if ($timestamp != "") {
                                $remote_file .= "/" . $timestamp;
                            }
                            
                            ftp_mkdir($conn, $remote_file);
                            ftp_put($conn, $remote_file, $super_archive.$format, FTP_BINARY);
                            ftp_quit( $conn );    
                            
                            $this->logger( $use_log,  '--- transfer "super" archive');     
                            
                            break;

                        default:
                        
                            $this->logger( $use_log,  '--- error ... no offsite set, or recognized.' ); 

                    }
                    
                    $this->logger( $use_log,  '--- archiving complete, start clean up:' );
                    
		            foreach ($files as $i => $file) {
						if (file_exists( $file )) {
							unlink( $file );
							$this->logger( $use_log,  '--- --- remove file ' . $i + 1 );
						}
					}
					
					unlink( $super_archive.$format ); 
					$this->logger( $use_log,  '--- --- remove "super" archive' ); 

                    $this->logger( $use_log,  '--- cleanup complete' );
                    
                }
  
                ?>

                </pre><!-- close #output -->

            </div>
    		<?php
          // End plugin ui	
    		
    	} // End function init()
    	
    	function logger( $use_log, $message ) {

            if ($use_log != "true") return;

            $log_message = "[".date("Y-m-d g:i:s a")."] " . $message ."\n";
            
            $log = ( defined('WP_CONTENT_DIR') ) ? WP_CONTENT_DIR : ABSPATH . 'wp-content';
            $log .= "/wpTimeMachine_log.txt";
            
            $log_handle = fopen($log, 'a+');
            fwrite($log_handle, $log_message);
            fclose($log_handle);
            
    	}
    	
        function getAdminOptions() {
        
    		$wpTimeMachineOptions = unserialize(wpTimeMachineOptions);
                
            $wpTimeMachineOptionsStorage = get_option($this->adminOptionsName);
            
            if (!empty($wpTimeMachineOptionsStorage)) {
                foreach ($wpTimeMachineOptionsStorage as $key => $option) {
                    $wpTimeMachineOptions[$key] = $option;
                }    
            }  
                      
            update_option($this->adminOptionsName, $wpTimeMachineOptions);
            
            return $wpTimeMachineOptions;
            
        } // End function getAdminOptions()
        
	}

} // End Class wpTimeMachine

// Instantiate Class
if (class_exists("wpTimeMachine")) {
	$wpTimeMachine = new wpTimeMachine();
}

// Insert link in menu for Admin Pages
if (!function_exists("wpTimeMachine_ap")) {
	function wpTimeMachine_ap() {
        global $wpTimeMachine;
        if (!isset($wpTimeMachine)) {
            return;
        }
        if (function_exists('add_options_page')) {
            add_options_page('wp Time Machine', 'wp Time Machine', 9, basename(__FILE__), array(&$wpTimeMachine, 'init'));
        }
	}	
}

// Deactivation function
function wpTimeMachine_deactivate() {

    $log = ( defined('WP_CONTENT_DIR') ) ? WP_CONTENT_DIR : ABSPATH . 'wp-content';
    $log .= "/wpTimeMachine_log.txt";
    
    unlink( $log );
            
    $wpTimeMachineOptions = unserialize(wpTimeMachineOptions);
        
    foreach ($wpTimeMachineOptions as $key => $option) {
        delete_option( $wpTimeMachineOptions[$key] );
    }  

}

// WP Actions
if (isset($wpTimeMachine)) {

	add_action('admin_menu', 'wpTimeMachine_ap');
    add_action('wp-time-machine/wp-time-machine.php',  array(&$wpTimeMachine, 'init'));
    register_deactivation_hook('wp-time-machine/wp-time-machine.php', 'wpTimeMachine_deactivate');
	
}

?>
